﻿// gdplayer 0.9.8 Vista/7
/*
 *    gdplayer is free software: you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation, either version 3 of the License, or
 *    (at your option) any later version.
 *
 *    gdplayer is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 */
// http://gdplayer.blogspot.com

var version = 098;
var gdp_version = "gdplayer " + System.Gadget.version;
var skin_id = 1;
var id = 0;
var temp_id = 0;

var online_playlist = true;
var stream = new Array();
var group = new Array();

var date_time = 0;

var last_date = null;
var anim = null;

var status_timeout = 9;
var status_enabled = true;
var status_data = "";
var status_bank = 1;
var opacity = 10;
var buttons_visible = false;
var ctrl_state = false;

System.Gadget.settingsUI = "options.html";
System.Gadget.onSettingsClosed = settingsClosed; 

System.Gadget.onDock = fnChkState;
System.Gadget.onUndock = fnChkState;

function settingsClosed(p_event) {
    //OK clicked?
    if (p_event.closeAction == p_event.Action.commit) {
		getSettings();
		fnChangeSkin();
		fnChkState();
		
		if (getValue("online_playlist") == true) {
			fnGetOnlinePlaylist();
		} else {
			fnLoadMyList();
		}
    }
}
//-------------------------------------- GET SETTINGS
function getSettings() {
	try {
		id = getValue("last_stream") ? getValue("last_stream") : 0; 
		volume = getValue("volume") ? getValue("volume") : 50;
		
		if (getValue("online_playlist")) {
			online_playlist = true;
			putValue("online_playlist",online_playlist);
		} else { 
			online_playlist = getValue("online_playlist");
		}
		
		if (getValue("skin_id") == "") { skin_id = 1; } else { skin_id = getValue("skin_id"); }
		if (getValue("date_time") == "") { date_time = 0; } else { date_time = getValue("date_time"); }
		
		btn_clock.src = "images/btn_clock_" + date_time + ".png";
		
		status_bank = 1;
		fnRefreshStatus();
		
	} catch(err) {
		//alert("id:"+id+"\nbgrd_id:"+bgrd_id+"\nauto_play:"+auto_play+"\ndate_time:"+date_time+"\nam_pm:"+am_pm);
		alert("Error: ",err.description);
	}
}

function getValue(variable) {
	return System.Gadget.Settings.read(variable);
}
function putValue(variable, key_data) {
	System.Gadget.Settings.write(variable, key_data);
}

//-------------------------------------- VIEW ON OPEN
function view_onOpen() {
	btn_clock.src = "images/btn_clock_0.png";
	//btn_online.src = "images/btn_online_on.png";
	getSettings();
	
	if (online_playlist == true) {
		fnGetOnlinePlaylist();
		btn_online.src = "images/btn_online_on.png";
	} else {
		fnLoadMyList();
		btn_online.src = "images/btn_online_off.png";
	}
	
	temp_id = id;
	
	fnChkState();
	fnChangeSkin();
	fnFadeOut();
	fnClockDraw();
	fnTimeUpdate();
	
	fnChangeTooltips(id);
	btn_mute.alt = MUTE;
	btn_clock.alt = OPT_DATE_TIME;
	btn_edit.alt = EDIT;
	document.getElementById("volume_root").title = VOLUME;
	document.getElementById("volume_handle").title = VOLUME;

	fnRefreshStatus();
	setInterval('fnTimeUpdate()', 1000);

	lbl_search.innerHTML = "<a href='http://www.google.com/'><img src='images/btn_search.png' alt='Google'></a>";

	if (getValue("updates") == true) { fnChkUpdates(); }

}
//-------------------------------------- NEXT / PREV
function fnNextStation() {
	if (!stream.length > 0) { return; }
	temp_id == stream.length - 1 ? temp_id = 0 : temp_id++;
	fnUpdateInfo();
}

function fnPrevStation() {
	if (!stream.length > 0) { return; }
	temp_id == 0 ? temp_id = stream.length - 1 : temp_id--;
	fnUpdateInfo();
}

function fnUpdateInfo() {
	status_bank = 97;
	fnRefreshStatus();

	btn_playstop.src = "images/btn_play.png";
	document.getElementById("btn_playstop").onclick = function() { fnPlay(); }
	
	if (getValue("auto_play")==true) {
		id = temp_id;
		fnPlay(); 
	}
}

//-------------------------------------- PLAY / STOP
function fnPlay() {
	if (!stream.length > 0) { return; }
	try {
		if (id != temp_id) { id = temp_id; }
		System.Gadget.Settings.write("last_stream", id);
		
		if (getValue("caps_on") == true) { 
			document.getElementById("lbl_station").innerHTML = "<a href='javascript:fnGetMediaInfo();'>" + stream[id].name.toUpperCase() + "</a>";
		} else {
			document.getElementById("lbl_station").innerHTML = "<a href='javascript:fnGetMediaInfo();'>" + stream[id].name + "</a>";
		}
		lbl_title.innerText = "";
		
		btn_playstop.src = "images/btn_stop.png";
		fnChangeTooltips(id);
		btn_playstop.alt = STOP;
		btn_edit.alt = EDIT + " " + stream[id].name;
		
		document.getElementById("btn_playstop").onclick= function() { fnStop(); }

		var url = stream[id].url;
		var a = url.length - 4;
		if (url.substring(a) == ".pls") {
			fnPlayPLS();
		} else {
			player.url =  stream[id].url;
			//alert("play : [ " + id + " ] " + stream[id].name + " @ " + player.url);
			player.controls.play();
		}
	} catch(e) {
		//alert("play: " + e.message);
		status_bank = 96;
	}
}
function fnStop() {
	player.controls.stop();
	btn_playstop.src = "images/btn_play.png";
	btn_playstop.alt = PLAY + " (" + stream[id].name + ")";
	status_bank = 1;
	fnRefreshStatus();
	document.getElementById("btn_playstop").onclick= function() { fnPlay(); }
	
	var data = "<a href='http://www.google.com/'><img src='images/btn_search.png' alt='Google'></a>";		
	lbl_search.innerHTML = data;
	return;
}
//-------------------------------------- VOLUME & MUTE
function fnSetVolume(pixelVolume){
	var volume=Math.round(pixelVolume);
	 fnVolumeChange(volume);
}
function fnVolumeChange(x) {
	var volume = player.settings.volume + x;
	player.settings.volume = x;
	status_bank = 98;
	fnRefreshStatus();
	putValue("volume",x);

	if (x == 0) {
		btn_mute.src = "images/btn_mute_on.png";
		player.settings.mute = true;
	} else {
		btn_mute.src = "images/btn_mute_off.png";
		player.settings.mute = false;
	}
}
function fnMute() {
	var mute = player.settings.mute;
	mute = !mute;
	player.settings.mute = mute;

	if(mute) {
		btn_mute.src = "images/btn_mute_on.png";
	} else {
		btn_mute.src = "images/btn_mute_off.png";
	}
}

//-------------------------------------- CLOCK ON/OFF
function fnClockOnOff() {
	date_time++;
	//alert("d++: " + date_time);
	if (date_time == 3) { date_time = 0; }
	putValue("date_time", date_time);
	fnClockDraw();
}
function fnClockDraw() {
	//alert("ClockDraw: " + date_time);
	btn_clock.src = "images/btn_clock_" + date_time + ".png";
	
	if (date_time != 0) { // DATE TIME ON
		if (System.Gadget.docked) { 
			document.getElementById("lbl_title").style.width = "114px";
		} else {
			document.getElementById("lbl_title").style.width = "105px";
		}
	} else { // DATE TIME OFF
		if (System.Gadget.docked) {
			document.getElementById("lbl_title").style.width = "114px";
		} else {
			document.getElementById("lbl_title").style.width = "184px";
		}
	}		
	
	status_bank = 94;
	fnRefreshStatus();
}
//-------------------------------------- EDIT STREAM
function fnEdit() {
	if (id == null) { return; }
	
	var old_name = stream[id].name;
	var old_url = stream[id].url;
	var old_homepage = stream[id].homepage;
	
	var new_name = prompt(OPT_ENTERNAME + ": ", old_name);
	if (new_name) { 
		var new_url = prompt(OPT_NEWURL + ": ", old_url);
		if (new_url) { 
			var new_homepage = prompt(OPT_HOMEPAGE + ": ", old_homepage);
			if (new_homepage) { 
				stream[id].name = new_name;
				stream[id].url = new_url; 
				stream[id].homepage = new_homepage; 
				status_bank = 1;
				fnRefreshStatus();

				// ------------------------------------------------------------------- SAVE MODIFIED gdplayer_playlist.xml

				var xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
				xmlDoc.async = false;

				var xml_string = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n";
				xml_string += "<general>\n";

				for (var i=0; i<group.length; ++i) {
					xml_string += "<group name='" + xmlencode(group[i]) + "'>\n";
					for (var j=0; j<stream.length; ++j) {
						if (stream[j].group == group[i]) {
							xml_string += "<stream>\n";
							xml_string += "<name>" + xmlencode(stream[j].name) + "</name>\n";
							xml_string += "<url>" + xmlencode(stream[j].url) +"</url>\n";
							xml_string += "<homepage>" + xmlencode(stream[j].homepage) +"</homepage>\n";
							xml_string += "</stream>\n";
						}
					}
					xml_string += "</group>\n";
				}
				xml_string += "</general>";
				
				xmlDoc.loadXML(xml_string);

				try {
					var parseError = xmlDoc.parseError;
					if (parseError.errorCode == 0) {
						xmlDoc.save(System.Gadget.path + "\\gdplayer_playlist.xml");
						xmlDoc.close;
						//alert("gdplayer_playlist.xml saved...");
					}
				} catch(e) {
					alert(e.message);
					//lbl_title.innerText = "failed to save playlist";
					//debug.error("failed to save playlist");
					return;
				}
			}
		}
	}

}
//-------------------------------------- ONLINE PLAYLIST ON/OFF
function fnOnlinePlaylistOnOff() {
	id = 0;
	online_playlist = !online_playlist;
	online_playlist == true ? fnGetOnlinePlaylist() : fnLoadMyList();
	putValue("online_playlist", online_playlist);
	
	if(online_playlist) {
		btn_online.src = "images/btn_online_on.png";
	} else {
		btn_online.src = "images/btn_online_off.png";
	}
	status_bank = 92;
	fnRefreshStatus();
}
//-------------------------------------- MOUSE WHEEL
function fnMouseWheel() {
  if (event.wheelDelta > 0) {
		switch (ctrl_state) {
			case 16:	// shift + wheel
				fnVolumeChange(player.settings.volume + 5);
				document.getElementById("volume_handle").style.left = player.settings.volume;
			break;
			default:
				fnPrevStation(); // wheel only
		}
  } else {
		switch (ctrl_state) {
			case 16:	
				fnVolumeChange(player.settings.volume - 5);
				document.getElementById("volume_handle").style.left = player.settings.volume;
			break;
			default:
				fnNextStation();
		}
	}
}

//-------------------------------------- KEY DOWN / UP
function fnKeyDown() {
  var KeyID = event.keyCode;
	//alert(KeyID);
	switch (KeyID) {
		case 16: // shift
			ctrl_state = KeyID;
		break;
		case 17: // ctrl
			ctrl_state = KeyID;
		break;
		case 32: // space
			if (player.playstate == 3) { 
				fnStop(); 
			} else {
				fnPlay();
			}
		break;
		case 37: // <-
			fnPrevStation();
		break;
		case 38: // arrow up
			if (volume_bar.value > 99) { volume_bar.value = 100; return; }
			fnVolumeChange(player.settings.volume + 5);
			document.getElementById("volume_handle").style.left = player.settings.volume;
		break;
		case 39: // ->
			fnNextStation();
		break;
		case 40: // arrow down
			if (volume_bar.value < 1) { volume_bar.value = 0; return; }	
			fnVolumeChange(player.settings.volume - 5);
			document.getElementById("volume_handle").style.left = player.settings.volume;
		break;
		case 77: // M
			fnMute();
		break;
	}
}
function fnKeyUp() {
	ctrl_state = 0;
}

//-------------------------------------- REFRESH STATUS
function fnRefreshStatus() {
	if (status_bank > 10) {
		fnIsAnimating();
		document.getElementById("lbl_status").style.filter = 'alpha(opacity=100)';
	}
//alert("status:" + status_bank);
	switch (status_bank) {
		case 0: //default
			lbl_title.innerText = gdp_version;
			status_data = READY_TO_PLAY;
			status_enabled = false;
		break;
		case 1: //station + group
			status_timeout = 10;
			try {
				if (getValue("caps_on") == true) {			
					document.getElementById("lbl_station").innerHTML =  "<a href='javascript:fnGetMediaInfo();'>" + stream[id].name.toUpperCase() + "</a>"; //np_station;
				} else {
					document.getElementById("lbl_station").innerHTML =  "<a href='javascript:fnGetMediaInfo();'>" + stream[id].name + "</a>"; //np_station;
				}
				status_data = stream[id].group;
				temp_id = id;
				if (player.playState == 3) { 
					btn_playstop.src = "images/btn_stop.png";
					document.getElementById("btn_playstop").onclick= function() { fnStop(); }
					fnChangeTooltips(getValue("last_stream"));
					btn_playstop.alt = STOP;
				} else {
					lbl_title.innerText = gdp_version;
				}
			} catch(e) {
				lbl_station.innerText = "";
			}
			fnChangeTooltips(id);
		break;
		case 2: //wmp status
			status_data = fnGetPlayerState();
			status_timeout = 10;
		break;
		case 3: //station's homepage
			if (!stream.length > 0) { return; }
			status_data = "<a href='" + stream[id].homepage + "'>" + stream[id].homepage + "</a>";
			status_timeout = 10;
		break;
		case 4:
			status_data = "";
		break;
		case 92: //online databaze on/off
			if(online_playlist) {
				status_data = "Online playlist ON";
			} else {
				status_data = "Online playlist OFF";
			}
			status_enabled = true;
			status_timeout = 10;
		break;
		case 93: // 
			if (getValue("caps_on") == true) {
					lbl_station.innerText = stream[id].name.toUpperCase();
					lbl_title.innerText = lbl_title.innerText.toUpperCase();
					
					document.getElementById("lbl_station").innerHTML =  "<a href='javascript:fnGetMediaInfo();'>" + stream[id].name.toUpperCase() + "</a>"; //np_station;
			} else {
					lbl_station.innerText = stream[id].name.toLowerCase();
					lbl_title.innerText = lbl_title.innerText.toLowerCase();
					document.getElementById("lbl_station").innerHTML =  "<a href='javascript:fnGetMediaInfo();'>" + stream[id].name + "</a>"; //np_station;
			}
		break;
		case 94: // date & time
			status_data = OPT_DATE_TIME + ": ";
			if (date_time == 0) { status_data += OPT_OFF; }
			if (date_time == 1) { status_data += OPT_AMPM; }
			if (date_time == 2) { status_data += OPT_HOUR24; }			
			status_enabled = true;
			status_timeout = 5;
		break;
		case 95: //update available
			var page = "http://gdplayer.blogspot.com/p/download.html";
			status_data = "<a href='" + page + "'>" + DOWNLOAD + "</a>";
			status_timeout = 10;
			status_enabled = false;
		break;
		case 96: //url error
			lbl_title.innerText = "no signal";
			status_enabled = true;
			status_timeout = 5;
		break;
		case 97: //prev / next
			status_data = stream[temp_id].group;
			if (getValue("caps_on") == true) { 
				lbl_station.innerText = stream[temp_id].name.toUpperCase();
			} else {
				lbl_station.innerText = stream[temp_id].name;
			}
			fnChangeTooltips(temp_id);
			status_enabled = true;
			status_timeout = 5;
		break;
		case 98: //volume
			status_data = VOLUME + " : " + player.settings.volume  + "%";
			status_enabled = true;
			status_timeout = 5;
		break;
		case 99: //error - stream[] - fail
			lbl_station.innerText = "";
			lbl_title.innerText = "";
			status_data = " - - - ";
			status_enabled = true;
			status_timeout = 5;
		break;
	}
	
	if (player.playstate == 3) { 
		if (getValue("caps_on") == true) { 
			lbl_title.innerText = player.currentMedia.getItemInfo('Title').toUpperCase(); 
		} else {
			lbl_title.innerText = player.currentMedia.getItemInfo('Title'); 
		}
		var data = "<a href='http://www.google.com/search?q=" + player.currentMedia.getItemInfo('Title') + "'><img src='images/btn_search.png' alt='Google: " + player.currentMedia.getItemInfo('Title') + "'></a>";		
		lbl_search.innerHTML = data;
		
	}
	
	if (getValue("caps_on") == true) { 
		lbl_status.innerHTML = status_data.toUpperCase();
	} else { 
		lbl_status.innerHTML = status_data;
	}
	
	++status_bank;
	if (status_bank >= 4) { status_bank = 1; }
}
function fnIsAnimating() {
	if (anim != null) {
		clearInterval(anim);
		anim = null;
	}
}
function fnStatusFadeOut() {
	fnIsAnimating();
	opacity = 100;
	anim = setInterval(AnimateOut,20);
	
}
function fnStatusFadeIn() {
	fnIsAnimating();
	opacity = 0;
	anim = setInterval(AnimateIn,20);
}
function AnimateOut() {
	--opacity;
	document.getElementById("lbl_status").style.filter = 'alpha(opacity=' + opacity + ')';
	if (opacity == 0) {
		clearInterval(anim);
		fnRefreshStatus();
		fnStatusFadeIn();
	}
}
function AnimateIn() {
	++opacity;
	document.getElementById("lbl_status").style.filter = 'alpha(opacity=' + opacity + ')';
	if (opacity == 100) {
		clearInterval(anim);
		status_enabled = true; 
	}
}

function fnPlayerStateChanged() {
	status_bank = 2;
	fnRefreshStatus();
}
//-------------------------------------- TIME UPDATE
function fnTimeUpdate() {
	if (status_enabled == true) {
		--status_timeout;
		if (status_timeout == 3) {
			status_enabled = false;
			fnStatusFadeOut();
		}
	}
	
	if (date_time == 0) { return; }

	var time = new Date();
	var hours = time.getHours();
	var minutes = time.getMinutes();
	var month=new Array(12);
		month[0] = M0;
		month[1] = M1;
		month[2] = M2;
		month[3] = M3;
		month[4] = M4;
		month[5] = M5;
		month[6] = M6;
		month[7] = M7;
		month[8] = M8;
		month[9] = M9;
		month[10] = M10;
		month[11] = M11;
	var day=new Array(7);
		day[0]=D0;
		day[1]=D1;
		day[2]=D2;
		day[3]=D3;
		day[4]=D4;
		day[5]=D5;
		day[6]=D6;

	lbl_day_of_week.innerText = day[time.getDay()];
	
	if (time.getDate() < 10) { lbl_date.innerText = "0" + time.getDate(); } else { lbl_date.innerText =  time.getDate(); }
	lbl_month.innerText = month[time.getMonth()];
	lbl_year.innerText = time.getYear();
	
	if (date_time == 2) {
		lbl_ampm.innerText = "  ";
	} else {
		lbl_ampm.innerText = (hours < 12) ? AM : PM;
		hours = (hours > 12) ? hours - 12 : hours;
		hours = (hours == 0) ? 12 : hours;
	}

	hours = (hours < 10 ? "0" : "") + hours;
	minutes = (minutes < 10 ? "0" : "") + minutes;
	lbl_time.innerText = hours + ":" + minutes;
}

//-------------------------------------- GET PLAYER STATE
function fnGetPlayerState() {
	var x = player.playState;
	switch(x) {
		case 0: return IDLE;
		case 1: return STOPPED;
		case 2: return PAUSED;
		case 3: 
				var att_value =  player.currentMedia.getItemInfo('Title');
				lbl_title.innerText = att_value;
				return PLAYING + ": " + parseInt(player.network.bitRate/1000) +" Kbps";
		break;
		case 4: return "";
		case 5: return ""; 
		case 6: return BUFFERING;
		case 7: return WAITING;
		case 8: return MEDIA_ENDED;
		case 9: return TRANSITIONING;
		case 10:
				//btn_playstop.src = "images/btn_play.png";
				//btn_playstop.alt = PLAY + " (" + stream[id].name + ")";
				return READY_TO_PLAY;
		case 11: return RECONECTING;
	}
}

//-------------------------------------- FADE IN / OUT
function fnFadeIn() {
	if (date_time != 0) { time.style.visibility='hidden'; }
	lbl_title.style.visibility='hidden';
	buttons.style.visibility='visible';
	menu.style.visibility='visible';
	mute.style.visibility='visible';
	clock.style.visibility='visible';
	online.style.visibility='visible';
	lbl_search.style.visibility='visible';
	volume_bar.style.visibility='visible';
	edit.style.visibility='visible';
}
function fnFadeOut() {
	if (date_time != 0) { time.style.visibility='visible'; }
	if (!System.Gadget.docked) { lbl_title.style.visibility='visible'; }
	if ((System.Gadget.docked) && (date_time == 0)) { lbl_title.style.visibility='visible'; }
	buttons.style.visibility='hidden';
	menu.style.visibility='hidden';
	mute.style.visibility='hidden';
	clock.style.visibility='hidden';
	online.style.visibility='hidden';
	lbl_search.style.visibility='hidden';
	volume_bar.style.visibility='hidden';
	edit.style.visibility='hidden';
}
//-------------------------------------- MENU
function fnMenu() {
	System.Gadget.Flyout.file = "menu.html";
	System.Gadget.Flyout.show = true;
	var flyoutDoc = System.Gadget.Flyout.document;
	System.Gadget.Flyout.onShow = function() {
		flyoutDoc.getElementById("info").innerHTML = "<b>Playlist:</b> " + stream.length + " " + OPT_STATIONS;
	}
}

//-------------------------------------- GET MEDIA INFO
function fnGetMediaInfo() {
	if (player.currentMedia != null) {
		var att_num = player.currentMedia.attributeCount;
		var a = "";
		
		a += "<table>";
		for (var i=0; i<att_num; ++i) {
			var att_name = player.currentMedia.getAttributeName(i);
			var att_value = player.currentMedia.getItemInfo(att_name);
			var att_temp = att_name.toLowerCase();
			
			a += "<tr><td valign='top'><b>" + att_name + "</b></td>";
			a += "<td width='160'>";
			if (att_temp.indexOf("url") != -1) {
				a += "<a href='" + att_value + "'>" + att_value + "</a>";
			} else {
				a += att_value;
			}
			a += "</td></tr>";
		}
		a += "</table>";
		fnViewHTML(a);
	}
}

//-------------------------------------- SHOW HTML DETAILS
function fnViewHTML(data) {

	System.Gadget.Flyout.file = "flyout.html";
	System.Gadget.Flyout.show = true;
	var flyoutDoc = System.Gadget.Flyout.document;
	System.Gadget.Flyout.onShow = function() {
		flyoutDoc.getElementById("head1").innerHTML = "<a href='" + stream[id].homepage + "'>" + stream[id].name + "</a>";
		flyoutDoc.getElementById("head2").innerHTML = stream[id].group;
		flyoutDoc.getElementById("data").innerHTML = data;
		flyoutDoc.getElementById("pata").innerHTML = "<b><a href='http://gdplayer.4fan.cz/script/report.php'>" + REPORT + "</a></b>";
		//flyoutDoc.getElementById("data").enabled = true;
	}
}

//-------------------------------------- CHECK GADGET DOCKED STATE
function fnChkState() {
    if (System.Gadget.docked) { 
        fnIsDocked();
    } else {
        fnIsUndocked();
    }
}
//-------------------------------------- UNDOCKED
function fnIsUndocked() {	
	document.body.style.width = "200px";
	document.getElementById("bgrd").src = "images/bgrd_" + skin_id + "_undocked.png";
	document.getElementById("bgrd").style.width = "200px";
	document.getElementById("main").style.width = "200px";
	document.getElementById("lbl_station").style.width = "184px";
	document.getElementById("lbl_status").style.width = "184px";
	document.getElementById("buttons").style.width = "184px";
	document.getElementById("mute").style.left = "180px";
	document.getElementById("clock").style.left = "180px";
	document.getElementById("online").style.left = "180px";
	document.getElementById("time").style.left = "112px";
	document.getElementById("volume_bar").style.left = "47px";

	lbl_title.style.visibility = "visible";
	
	if (date_time != 0) { 
			document.getElementById("lbl_title").style.width = "105px";
	} else {
			document.getElementById("lbl_title").style.width = "184px";
	}
}
//-------------------------------------- DOCKED
function fnIsDocked() {
    document.body.style.width = "130px"; 
	document.getElementById("bgrd").src = "images/bgrd_" + skin_id + "_docked.png";
	document.getElementById("bgrd").style.width = "130px";
	document.getElementById("main").style.width = "130px";
	document.getElementById("lbl_station").style.width = "114px";
	document.getElementById("lbl_status").style.width = "114px";
	document.getElementById("buttons").style.width = "114px";
	document.getElementById("mute").style.left = "110px";
	document.getElementById("clock").style.left = "110px";
	document.getElementById("online").style.left = "110px";
	document.getElementById("time").style.left = "35px";
	document.getElementById("volume_bar").style.left = "12px";
	
	if (date_time) { 
		lbl_title.style.visibility = "hidden"; 
	} else {
		lbl_title.style.visibility = "visible"; 
		document.getElementById("lbl_title").style.width = "114px";
	}
}

//-------------------------------------- UPDATES
function fnChkUpdates() {

	var req = new XMLHttpRequest();
	//var url = "http://127.0.0.1/gdplayer/version.txt?r=" + Math.random();
	var url = "http://gdplayer.4fan.cz/gdplayer/version.txt?r=" + Math.random();
	
	//alert("downloading: " + url);
	req.open("GET", url, true);
	req.onreadystatechange = function() {
		if (req.readyState == 4 && req.status == 200) {
			//alert("version.txt is loaded & ready for use...");
			var ver_online = req.responseText;
			if (ver_online > version) { 
				lbl_title.innerText = NEW_VERSION;
				status_bank = 95;
				fnRefreshStatus();
			}
		}
    };
	req.send();
}

//-------------------------------------- CHANGE TOOLTIPS
function fnChangeTooltips(st_id) {
	if(stream.length > 0) {
		st_id == 0 ? btn_prev.alt = PREVIOUS + " (" + stream[stream.length - 1].name + ")" : btn_prev.alt = PREVIOUS + " (" + stream[st_id -1].name + ")";
		st_id == stream.length - 1 ? btn_next.alt = NEXT + " (" + stream[0].name + ")" : btn_next.alt = NEXT + " (" + stream[st_id + 1].name + ")";
		btn_playstop.alt = PLAY + " (" + stream[st_id].name + ")";
	} else {
		btn_prev.alt = PREVIOUS;
		btn_next.alt = NEXT;
		btn_playstop.alt = PLAY;
	}
}

//-------------------------------------- CHANGE SKIN
function fnChangeSkin() {
	
	//alert("skin: " + skin_id);
	document.getElementById("lbl_station").style.filter = 'alpha(opacity=80)';
	document.getElementById("lbl_title").style.filter = 'alpha(opacity=80)';
	document.getElementById("time").style.filter = 'alpha(opacity=80)';
	document.getElementById("volume_handle").style.left = volume;	
	
	switch (skin_id) {
		case 1: //default
			lbl_station.style.color  = "#FFFFFF";
			lbl_title.style.color = "#FFFC06";
			lbl_status.style.color = "#C0C0C0";
			lbl_time.style.color  = "#FFFFFF";
			lbl_ampm.style.color  = "#FFFFFF";
			lbl_date.style.color  = "#DDDDDD";
			lbl_month.style.color  = "#C0C0C0";
			lbl_day_of_week.style.color  = "#DDDDDD";
			lbl_year.style.color  = "#C0C0C0";
		break;
		
		case 2: 
			lbl_station.style.color  = "#FAFAFA";
			lbl_title.style.color = "#e28313";
			lbl_status.style.color = "#C0C0C0";
			lbl_time.style.color  = "#e28313";
			lbl_ampm.style.color  = "#e28313";
			lbl_date.style.color  = "#e28313";
			lbl_month.style.color  = "#CCCCCC";
			lbl_day_of_week.style.color  = "#FDFDFD";
			lbl_year.style.color  = "#CCCCCC";
		break;
		
		case 3: 
			lbl_station.style.color  = "#FFFFFF";
			lbl_title.style.color = "#FFFC06";
			lbl_status.style.color = "#FFFC06";
			lbl_time.style.color  = "#FFFFFF";
			lbl_ampm.style.color  = "#FFFFFF";
			lbl_date.style.color  = "#DDDDDD";
			lbl_month.style.color  = "#C0C0C0";
			lbl_day_of_week.style.color  = "#DDDDDD";
			lbl_year.style.color  = "#C0C0C0";
		break;
		
		case 4: 
			lbl_station.style.color  = "#e3ac28";
			lbl_title.style.color = "#d29c0f";
			lbl_status.style.color = "#9c6e00";
			lbl_time.style.color  = "#d29c0f";
			lbl_ampm.style.color  = "#d29c0f";
			lbl_date.style.color  = "#d29c0f";
			lbl_month.style.color  = "#9c6e00";
			lbl_day_of_week.style.color  = "#d29c0f";
			lbl_year.style.color  = "#7d5300";
		break;
		
		case 5: 
			lbl_station.style.color  = "#FFFFFF";
			lbl_title.style.color = "#FFFC06";
			lbl_status.style.color = "#FFFFFF";
			lbl_time.style.color  = "#FFFFFF";
			lbl_ampm.style.color  = "#FFFFFF";
			lbl_date.style.color  = "#DDDDDD";
			lbl_month.style.color  = "#FFFC06";
			lbl_day_of_week.style.color  = "#FFFC06";
			lbl_year.style.color  = "#DDDDDD";
		break;
		
		case 9: 
			lbl_station.style.color  = "#FFF00F";
			lbl_title.style.color = "#DDDDDD";
			lbl_status.style.color = "#CCCCCC";
			lbl_time.style.color  = "#FFFFFF";
			lbl_ampm.style.color  = "#FFFFFF";
			lbl_date.style.color  = "#EEEEEE";
			lbl_month.style.color  = "#CCCCCC";
			lbl_day_of_week.style.color  = "#AAAAAA";
			lbl_year.style.color  = "#DDDDDD";
		break;
		
		default:
			lbl_station.style.color  = "#FFFFFF";
			lbl_title.style.color = "#FFFC06";
			lbl_status.style.color = "#C0C0C0";
			lbl_time.style.color  = "#FFFFFF";
			lbl_ampm.style.color  = "#FFFFFF";
			lbl_date.style.color  = "#FFFFFF";
			lbl_month.style.color  = "#C0C0C0";
			lbl_day_of_week.style.color  = "#DDDDDD";
			lbl_year.style.color  = "#C0C0C0";
	}
	return;
}


